from gibson.structure.Entity import Entity


def structure_testing_get_entity():
    entity = Entity()
    entity.attributes = [
        {
            "as_": None,
            "bytes_": None,
            "check": None,
            "comment": None,
            "data_type": {"formatted": "bigint", "raw": "bigint"},
            "default": None,
            "extra": {"increment": {"auto": True}},
            "key": {"index": None, "primary": True, "unique": None},
            "length": None,
            "name": "id",
            "nullable": False,
            "numeric": {"precision": None, "scale": None},
            "on": None,
            "reference": None,
            "sql": "id bigint not null auto_increment primary key",
            "unsigned": None,
            "values": None,
        },
        {
            "as_": None,
            "bytes_": None,
            "check": None,
            "comment": None,
            "data_type": {"formatted": "varchar(36)", "raw": "varchar"},
            "default": None,
            "extra": {"increment": {"auto": None}},
            "key": {"index": None, "primary": None, "unique": True},
            "length": 36,
            "name": "uuid",
            "nullable": False,
            "numeric": {"precision": None, "scale": None},
            "on": None,
            "reference": None,
            "sql": "uuid varchar(36) not null unique key",
            "unsigned": None,
            "values": None,
        },
        {
            "as_": None,
            "bytes_": None,
            "check": None,
            "comment": None,
            "data_type": {"formatted": "datetime", "raw": "datetime"},
            "default": "current_timestamp",
            "extra": {"increment": {"auto": None}},
            "key": {"index": None, "primary": None, "unique": None},
            "length": None,
            "name": "date_created",
            "nullable": False,
            "numeric": {"precision": None, "scale": None},
            "on": None,
            "reference": None,
            "sql": "date_created datetime not null default current_timestamp",
            "unsigned": None,
            "values": None,
        },
        {
            "as_": None,
            "bytes_": None,
            "check": None,
            "comment": None,
            "data_type": {"formatted": "datetime", "raw": "datetime"},
            "default": "null",
            "extra": {"increment": {"auto": None}},
            "key": {"index": None, "primary": None, "unique": None},
            "length": None,
            "name": "date_updated",
            "nullable": None,
            "numeric": {"precision": None, "scale": None},
            "on": "update current_timestamp",
            "reference": None,
            "sql": "date_updated datetime default null on update current_timestamp",
            "unsigned": None,
            "values": None,
        },
    ]
    entity.constraints = {"check": []}
    entity.keys = {"foreign": [], "index": [], "primary": None, "unique": []}
    entity.name = "abc_def"
    entity.parameters = {
        "auto": None,
        "charset": None,
        "collate": None,
        "default": None,
        "engine": None,
        "sql": None,
    }

    return entity


def structure_testing_get_struct_data():
    return {
        "entity": {
            "name": "abc_def",
            "struct": {
                "attributes": [
                    {
                        "as_": None,
                        "bytes_": None,
                        "check": None,
                        "comment": None,
                        "data_type": {"formatted": "bigint", "raw": "bigint"},
                        "default": None,
                        "extra": {"increment": {"auto": True}},
                        "key": {"index": None, "primary": True, "unique": None},
                        "length": None,
                        "name": "id",
                        "nullable": False,
                        "numeric": {"precision": None, "scale": None},
                        "on": None,
                        "reference": None,
                        "sql": "id bigint not null auto_increment primary key",
                        "unsigned": None,
                        "values": None,
                    },
                    {
                        "as_": None,
                        "bytes_": None,
                        "check": None,
                        "comment": None,
                        "data_type": {"formatted": "varchar(36)", "raw": "varchar"},
                        "default": None,
                        "extra": {"increment": {"auto": None}},
                        "key": {"index": None, "primary": None, "unique": True},
                        "length": 36,
                        "name": "uuid",
                        "nullable": False,
                        "numeric": {"precision": None, "scale": None},
                        "on": None,
                        "reference": None,
                        "sql": "uuid varchar(36) not null unique key",
                        "unsigned": None,
                        "values": None,
                    },
                    {
                        "as_": None,
                        "bytes_": None,
                        "check": None,
                        "comment": None,
                        "data_type": {"formatted": "datetime", "raw": "datetime"},
                        "default": "current_timestamp",
                        "extra": {"increment": {"auto": None}},
                        "key": {"index": None, "primary": None, "unique": None},
                        "length": None,
                        "name": "date_created",
                        "nullable": False,
                        "numeric": {"precision": None, "scale": None},
                        "on": None,
                        "reference": None,
                        "sql": "date_created datetime not null default current_timestamp",
                        "unsigned": None,
                        "values": None,
                    },
                    {
                        "as_": None,
                        "bytes_": None,
                        "check": None,
                        "comment": None,
                        "data_type": {"formatted": "datetime", "raw": "datetime"},
                        "default": "null",
                        "extra": {"increment": {"auto": None}},
                        "key": {"index": None, "primary": None, "unique": None},
                        "length": None,
                        "name": "date_updated",
                        "nullable": None,
                        "numeric": {"precision": None, "scale": None},
                        "on": "update current_timestamp",
                        "reference": None,
                        "sql": "date_updated datetime default null on update current_timestamp",
                        "unsigned": None,
                        "values": None,
                    },
                ],
                "constraints": {"check": []},
                "keys": {"foreign": [], "index": [], "primary": None, "unique": []},
                "parameters": {
                    "auto": None,
                    "charset": None,
                    "collate": None,
                    "default": None,
                    "engine": None,
                    "sql": None,
                },
            },
        }
    }
